#pragma once

#include <SDL2/SDL.h>
#include <string>
#include <vector>

#include "app_consts.hpp"
#include "piece.hpp"

class Board
{
public:
    Board();
    Board(std::string board_fen);

    void load_FEN(std::string board_fen);

    void draw_board(SDL_Surface* dest_surface);

private:
    Piece game_board[BOARD_SIZE][BOARD_SIZE];
    Team active_color;
    bool able_to_castle[2][2];
    std::vector<int> en_passant;
    int half_turn_count, full_turn_count;
};
